<?php
/**
 * Callback file for incident storages POSTs
 */

include "radioactivity-bootstrap.inc";

$payload = _radioactivity_validate_payload($_POST);

if (!$payload) {
  print "Invalid post data";
  return;
}

$data = $payload['data'];
$data = json_decode($data, true);

require_once "includes/RadioactivityIncident.inc";
require_once "includes/RadioactivityIncidentStorage.inc";

if (is_array($data)) {
  foreach ($data as $storage => $entity_types) {
    $class = "Radioactivity" . ucfirst($storage) . "IncidentStorage";
    require_once "includes/" . $class . ".inc";
    $storage = new $class();
    if ($class::REQUIRE_BOOTSTRAP) {
      // verify boostrapping
      _radioactivity_require_bootstrapping();
    }
    foreach ($entity_types as $entity_type => $entities) {
      foreach ($entities as $bundle => $fields) {
        foreach ($fields as $field_name => $ids) {
          foreach ($ids as $entity_id => $energy) {
            $incident = new RadioactivityIncident(
                $entity_type,
                $bundle,
                $field_name,
                $entity_id,
                $energy,
                time()
            );
            $storage->addIncident($incident);
          }
        }
      }
    }
  }
}


